SystemOrganization addCategory: 'OrbeonPersistenceApi_Tests'!

TestCase subclass: #OrbeonPersistenceRestLayerTest
	instanceVariableNames: 'restClient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi_Tests'!

OrbeonPersistenceRestLayerTest subclass: #OrbeonPersistenceRestLayer2016_2_Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi_Tests'!

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'other' stamp: 'BrunoBB 12/19/2016 09:44'!
orbeonFormSummaryQuery

^
'<search>
    <query/>
    <query control="input" html-label="false" match="substring" name="name" path="section-1[1]/name[1]" search-field="true" summary-field="true" type="xs:string"/>
    <page-size>10</page-size>
    <page-number>1</page-number>
    <lang>en</lang>
</search>'! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'form-sales-customer' stamp: 'BrunoBB 12/21/2016 09:17'!
testDeleteFormDefinitionSalesCustomer
"	<delete>
	<path: '/crud/orbeon/builder/data/{1}/data.xml'>
"
	| result id |

	id := (self getOrbeonApplicationClass getLatestSavedDefinition: 'customer' app: 'sales-application' ifNone: [nil]) ifNotNil: [:def | def id] ifNil: [self assert: false] .

	self setClientUrlToDeleteFormDefinitionWithId: id.

	result := restClient delete.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'form-sales-customer' stamp: 'BrunoBB 12/21/2016 15:44'!
testDeleteFormInstanceDraftSalesCustomer
"	<delete>
	<path: '/crud/{app}/{form-name}/draft/{id}/data.xml'>
"
	| result id |

	(self getOrbeonApplicationClass formDefinitionNamed: 'customer' in: 'sales-application') 
		ifNil: [self assert: false] 
		ifNotNil: [:def | def drafts keysAndValuesDo: [:key :col | col do: [:each | each isDeleted ifFalse: [id := each id]]]]. 

	self setClientUrlToDeleteFormDraft: 'customer' in: 'sales-application' id: id.

	result := restClient delete.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'form-sales-customer' stamp: 'BrunoBB 12/21/2016 15:34'!
testDeleteFormInstanceSalesCustomer
"	<delete>
	<path: '/crud/{app}/{form-name}/data/{id}/data.xml'>
"
	| result id |

	id := (self getOrbeonApplicationClass formDefinitionNamed: 'customer' in: 'sales-application') 
				ifNil: [self assert: false] 
				ifNotNil: [:def | (def instances asArray detect: [:inst| inst deleted = 'N'] ifNone: [self assert: false]) id].

	self setClientUrlToDeleteFormInstance: 'customer' in: 'sales-application' id: id.

	result := restClient delete.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'form-sales-customer' stamp: 'BrunoBB 12/23/2016 03:32'!
testFormSummarySalesCustomer
"	<post>
	<produces: 'application/xml'>
	<path: '/search/{2}/{1}'>
"
	| result |

	self setClientUrlForFormSummary: 'customer' in: 'sales-application'.

	restClient entity: ((ZnStringEntity xml: self orbeonFormSummaryQuery) contentType: ZnMimeType applicationXml).

	result := restClient post.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'general' stamp: 'BrunoBB 12/21/2016 03:25'!
testOrbeonFr
	"This service is called when accessing Form Runner Home: ../orbeon/fr/ "
"	<get>
	<produces: 'application/xml'>
	<path: '/form'>
"
	| result |

	restClient 
		url: self gemstoneIP, '/orbeon-gemstone-api/form'.

	result := restClient get.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'form-sales-customer' stamp: 'BrunoBB 12/21/2016 09:25'!
testPublishNewFormSalesCustomer
"	<put>
	<consumes: 'application/xml'>
	<path: '/crud/{2}/{1}/form/form.xhtml?document={3}'>
"
	| result id |

	id := self getSavedDefinitionId: 'customer' in: 'sales-application'.

	self setClientUrlToPublishFormDefinition: 'customer' in: 'sales-application' id: id.

	restClient 
		entity: ((ZnStringEntity xml: OrbeonFormDefinitionTemplate form_sales_application) contentType: ZnMimeType applicationXml);
		headerAt: 'orbeon-form-definition-version' put: 'next'.

	result := restClient put.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'form-sales-customer' stamp: 'BrunoBB 12/21/2016 09:25'!
testSaveFormDefinitionSalesCustomer
"	<put>
	<path: '/crud/orbeon/builder/data/{id}/data.xml/?valid={aBoolean}'>
"
	| result id |

	id := self getSavedDefinitionId: 'customer' in: 'sales-application'.

	self setClientUrlToSaveFormDefinitionWithId: id.

	restClient contents: OrbeonFormDefinitionTemplate form_sales_application.
					
	result := restClient put.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'form-sales-customer' stamp: 'BrunoBB 12/21/2016 15:41'!
testSaveFormInstanceDraftSalesCustomer
"	<put>
	<produces: 'application/xml'>
	<path: '/crud/{app}/{form-name}/draft/{id}/data.xml?valid={true|false}'>
"
	| result id version |

	version := (self getOrbeonApplicationClass getLatestSavedDefinition: 'customer' app: 'sales-application' ifNone: [nil]) ifNotNil: [:def | def version printString] ifNil: ['1'].
	id := UUID new asString.

	self setClientUrlToSaveFormDraft: 'customer' in: 'sales-application' id: id.

	restClient 
		headerAt: 'orbeon-form-definition-version' put: version;
		entity: ((ZnStringEntity xml: OrbeonFormInstanceTemplate form_sales_application_01) contentType: ZnMimeType applicationXml).

	result := restClient put.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'form-sales-customer' stamp: 'BrunoBB 12/21/2016 15:29'!
testSaveFormInstanceSalesCustomer
"	<put>
	<produces: 'application/xml'>
	<path: '/crud/{app}/{form-name}/data/{id}/data.xml?valid={true|false}'>
"
	| result id version |

	version := (self getOrbeonApplicationClass getLatestSavedDefinition: 'customer' app: 'sales-application' ifNone: [nil]) ifNotNil: [:def | def version printString] ifNil: ['1'].
	id := UUID new asString.

	self setClientUrlToSaveFormInstance: 'customer' in: 'sales-application' id: id.
	restClient 
		headerAt: 'orbeon-form-definition-version' put: version;
		entity: ((ZnStringEntity xml: OrbeonFormInstanceTemplate form_sales_application_01) contentType: ZnMimeType applicationXml).

	result := restClient put.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'form-sales-customer' stamp: 'BrunoBB 12/21/2016 16:54'!
testSaveFormInstanceSalesCustomerBeethoven
"	<put>
	<produces: 'application/xml'>
	<path: '/crud/{app}/{form-name}/data/{id}/data.xml?valid={true|false}'>
"
	| result id version |

	version := (self getOrbeonApplicationClass getLatestSavedDefinition: 'customer' app: 'sales-application' ifNone: [nil]) ifNotNil: [:def | def version printString] ifNil: ['1'].
	id := UUID new asString.

	self setClientUrlToSaveFormInstance: 'customer' in: 'sales-application' id: id.
	restClient 
		headerAt: 'orbeon-form-definition-version' put: version;
		entity: ((ZnStringEntity xml: OrbeonFormInstanceTemplate form_sales_application_Beethoven) contentType: ZnMimeType applicationXml).

	result := restClient put.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'form-sales-customer' stamp: 'BrunoBB 12/21/2016 16:54'!
testSaveFormInstanceSalesCustomerChaikovski
"	<put>
	<produces: 'application/xml'>
	<path: '/crud/{app}/{form-name}/data/{id}/data.xml?valid={true|false}'>
"
	| result id version |

	version := (self getOrbeonApplicationClass getLatestSavedDefinition: 'customer' app: 'sales-application' ifNone: [nil]) ifNotNil: [:def | def version printString] ifNil: ['1'].
	id := UUID new asString.

	self setClientUrlToSaveFormInstance: 'customer' in: 'sales-application' id: id.
	restClient 
		headerAt: 'orbeon-form-definition-version' put: version;
		entity: ((ZnStringEntity xml: OrbeonFormInstanceTemplate form_sales_application_Chaikovski) contentType: ZnMimeType applicationXml).

	result := restClient put.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'form-sales-customer' stamp: 'BrunoBB 12/21/2016 16:55'!
testSaveFormInstanceSalesCustomerDale
"	<put>
	<produces: 'application/xml'>
	<path: '/crud/{app}/{form-name}/data/{id}/data.xml?valid={true|false}'>
"
	| result id version |

	version := (self getOrbeonApplicationClass getLatestSavedDefinition: 'customer' app: 'sales-application' ifNone: [nil]) ifNotNil: [:def | def version printString] ifNil: ['1'].
	id := UUID new asString.

	self setClientUrlToSaveFormInstance: 'customer' in: 'sales-application' id: id.
	restClient 
		headerAt: 'orbeon-form-definition-version' put: version;
		entity: ((ZnStringEntity xml: OrbeonFormInstanceTemplate form_sales_application_Dale) contentType: ZnMimeType applicationXml).

	result := restClient put.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'form-sales-customer' stamp: 'BrunoBB 12/21/2016 16:55'!
testSaveFormInstanceSalesCustomerMorissette
"	<put>
	<produces: 'application/xml'>
	<path: '/crud/{app}/{form-name}/data/{id}/data.xml?valid={true|false}'>
"
	| result id version |

	version := (self getOrbeonApplicationClass getLatestSavedDefinition: 'customer' app: 'sales-application' ifNone: [nil]) ifNotNil: [:def | def version printString] ifNil: ['1'].
	id := UUID new asString.

	self setClientUrlToSaveFormInstance: 'customer' in: 'sales-application' id: id.
	restClient 
		headerAt: 'orbeon-form-definition-version' put: version;
		entity: ((ZnStringEntity xml: OrbeonFormInstanceTemplate form_sales_application_Morissette) contentType: ZnMimeType applicationXml).

	result := restClient put.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'form-sales-customer' stamp: 'BrunoBB 12/21/2016 16:55'!
testSaveFormInstanceSalesCustomerSting
"	<put>
	<produces: 'application/xml'>
	<path: '/crud/{app}/{form-name}/data/{id}/data.xml?valid={true|false}'>
"
	| result id version |

	version := (self getOrbeonApplicationClass getLatestSavedDefinition: 'customer' app: 'sales-application' ifNone: [nil]) ifNotNil: [:def | def version printString] ifNil: ['1'].
	id := UUID new asString.

	self setClientUrlToSaveFormInstance: 'customer' in: 'sales-application' id: id.
	restClient 
		headerAt: 'orbeon-form-definition-version' put: version;
		entity: ((ZnStringEntity xml: OrbeonFormInstanceTemplate form_sales_application_Sting) contentType: ZnMimeType applicationXml).

	result := restClient put.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'form-sales-customer' stamp: 'BrunoBB 12/21/2016 16:55'!
testSaveFormInstanceSalesCustomerTyson
"	<put>
	<produces: 'application/xml'>
	<path: '/crud/{app}/{form-name}/data/{id}/data.xml?valid={true|false}'>
"
	| result id version |

	version := (self getOrbeonApplicationClass getLatestSavedDefinition: 'customer' app: 'sales-application' ifNone: [nil]) ifNotNil: [:def | def version printString] ifNil: ['1'].
	id := UUID new asString.

	self setClientUrlToSaveFormInstance: 'customer' in: 'sales-application' id: id.
	restClient 
		headerAt: 'orbeon-form-definition-version' put: version;
		entity: ((ZnStringEntity xml: OrbeonFormInstanceTemplate form_sales_application_Tyson) contentType: ZnMimeType applicationXml).

	result := restClient put.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayerTest methodsFor: 'other' stamp: 'BrunoBB 12/21/2016 03:24'!
gemstoneIP

	^GemStoneServerConfiguration default gemstoneIP! !

!OrbeonPersistenceRestLayerTest methodsFor: 'other' stamp: 'BrunoBB 12/21/2016 09:22'!
getSavedDefinitionId: formName in: appName

	^(self getOrbeonApplicationClass getLatestSavedDefinition: formName app: appName ifNone: [nil]) 
		ifNotNil: [:definition | definition id] 
		ifNil: [UUID new asString].! !

!OrbeonPersistenceRestLayerTest methodsFor: 'Accessing' stamp: 'BrunoBB 12/17/2016 08:19'!
restClient
	^restClient! !

!OrbeonPersistenceRestLayerTest methodsFor: 'Updating' stamp: 'BrunoBB 12/17/2016 08:19'!
restClient: newValue
	restClient := newValue! !

!OrbeonPersistenceRestLayerTest methodsFor: 'service-delete' stamp: 'BrunoBB 12/21/2016 04:03'!
setClientUrlForFormSummary: formName in: appName

	restClient url: self gemstoneIP, '/orbeon-gemstone-api/search/', appName,'/', formName! !

!OrbeonPersistenceRestLayerTest methodsFor: 'service-delete' stamp: 'BrunoBB 12/21/2016 03:55'!
setClientUrlToDeleteFormDefinitionWithId: id

	restClient url: self gemstoneIP, '/orbeon-gemstone-api/crud/orbeon/builder/data/', id, '/data.xml'! !

!OrbeonPersistenceRestLayerTest methodsFor: 'service-delete' stamp: 'BrunoBB 12/21/2016 03:58'!
setClientUrlToDeleteFormDraft: formName in: appName id: id

	restClient url: self gemstoneIP, '/orbeon-gemstone-api/crud/', appName, '/', formName, '/draft/', id, '/data.xml'! !

!OrbeonPersistenceRestLayerTest methodsFor: 'service-delete' stamp: 'BrunoBB 12/21/2016 03:57'!
setClientUrlToDeleteFormInstance: formName in: appName id: id

	restClient url: self gemstoneIP, '/orbeon-gemstone-api/crud/', appName, '/', formName, '/data/', id, '/data.xml'! !

!OrbeonPersistenceRestLayerTest methodsFor: 'service-delete' stamp: 'BrunoBB 12/21/2016 04:08'!
setClientUrlToPublishFormDefinition: formName in: appName id: id

	restClient url: self gemstoneIP, '/orbeon-gemstone-api/crud/', appName, '/', formName, '/form/form.xhtml?document=', id.! !

!OrbeonPersistenceRestLayerTest methodsFor: 'service-delete' stamp: 'BrunoBB 12/21/2016 04:07'!
setClientUrlToSaveFormDefinitionWithId: id

	restClient url: self gemstoneIP, '/orbeon-gemstone-api/crud/orbeon/builder/data/', id, '/data.xml/?valid=true'! !

!OrbeonPersistenceRestLayerTest methodsFor: 'service-delete' stamp: 'BrunoBB 12/21/2016 04:16'!
setClientUrlToSaveFormDraft: formName in: appName id: id

	restClient url: self gemstoneIP, '/orbeon-gemstone-api/crud/', appName, '/', formName, '/draft/', id, '/data.xml?valid=true'.! !

!OrbeonPersistenceRestLayerTest methodsFor: 'service-delete' stamp: 'BrunoBB 12/21/2016 04:15'!
setClientUrlToSaveFormInstance: formName in: appName id: id

	restClient url: self gemstoneIP, '/orbeon-gemstone-api/crud/', appName, '/', formName, '/data/', id, '/data.xml?valid=true'.! !

!OrbeonPersistenceRestLayerTest methodsFor: 'other' stamp: 'BrunoBB 12/17/2016 08:19'!
setUp

	super setUp.

	restClient := ZnClient new.! !

!OrbeonPersistenceRestLayerTest methodsFor: 'other' stamp: 'BrunoBB 12/17/2016 08:19'!
tearDown

	super tearDown.

	restClient close.! !

TestCase subclass: #OrbeonSearchApiTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi_Tests'!

OrbeonSearchApiTest subclass: #OrbeonDefinitionSearchApiTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi_Tests'!

OrbeonSearchApiTest subclass: #OrbeonInstanceSearchApiTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi_Tests'!

!OrbeonInstanceSearchApiTest methodsFor: 'other' stamp: 'BrunoBB 12/24/2016 06:22'!
testSearchWithoutCriteria
|str|
str := '<search>
    <query/>
    <query control="input" html-label="false" match="substring" name="completeName" path="section-1[1]/completeName[1]" search-field="true" summary-field="true" type="xs:string"/>
    <page-size>10</page-size>
    <page-number>1</page-number>
    <lang>en</lang>
</search>'.
(OrbeonInstanceSearchApi for: 
(OrbeonApplication applicationNamed: 'sales-application')
formName: 'customer')
	xmlSearchDefinitionDocument: (XMLDOMParser parse: str);
	createQueryNodes;
	getPageSize;
	getPageNumber;
	group: 'admin';
	user: 'admin';
	executeQuery! !
